diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontUnicode.java b/game/client/src/main/java/net/minecraft/client/render/font/FontUnicode.java
new file mode 100644
index 000000000..911b9c463
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontUnicode.java
@@ -0,0 +1,15 @@
+package net.minecraft.client.render.font;
+
+import net.minecraft.client.render.TextureManager;
+import org.jetbrains.annotations.NotNull;
+
+public class FontUnicode extends FontFile {
+    public FontUnicode(final @NotNull TextureManager textureManager) {
+        super(textureManager, "/font/glyph_%02X.png", "/font/glyph_sizes.bin");
+    }
+    @Override
+    public boolean canRenderChar(final char c) {
+        return c == ' ' || textureForChar(c) != 0;
+    }
+
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/SF.java b/game/client/src/main/java/net/minecraft/client/render/font/SF.java
new file mode 100644
index 000000000..b2751647c
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/font/SF.java
@@ -0,0 +1,63 @@
+package net.minecraft.client.render.font;
+
+/**
+ * Short for String Formatting
+ */
+public final class SF {
+    public static final long MASK_COLOR = 0x00_00_00_00__FF_FF_FF_FFL;
+    public static final long ITALIC = (0b0000_0001L << 32);
+    public static final long UNDERLINE = (0b0000_0010L << 32);
+    public static final long STRIKETHROUGH = (0b0000_0100L << 32);
+    public static final long BOLD = (0b0000_1000L << 32);
+    public static final long OBFUSCATED = (0b0001_0000L << 32);
+
+    private SF() {}
+
+    public static long setItalic(final long config) {
+        return config | ITALIC;
+    }
+
+    public static boolean isItalic(final long config) {
+        return (config & ITALIC) != 0;
+    }
+
+    public static long setUnderline(final long config) {
+        return config | UNDERLINE;
+    }
+
+    public static boolean isUnderline(final long config) {
+        return (config & UNDERLINE) != 0;
+    }
+
+    public static long setStrikethrough(final long config) {
+        return config | STRIKETHROUGH;
+    }
+
+    public static boolean isStrikethrough(final long config) {
+        return (config & STRIKETHROUGH) != 0;
+    }
+
+    public static long setBold(final long config) {
+        return config | BOLD;
+    }
+
+    public static boolean isBold(final long config) {
+        return (config & BOLD) != 0;
+    }
+
+    public static long setObfuscated(final long config) {
+        return config | OBFUSCATED;
+    }
+
+    public static boolean isObfuscated(final long config) {
+        return (config & OBFUSCATED) != 0;
+    }
+
+    public static long setColor(final long config, final int color) {
+        return (config & ~MASK_COLOR) | color & MASK_COLOR;
+    }
+
+    public static int getColor(final long config) {
+        return (int) (config & MASK_COLOR);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/FontHelper.java b/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/FontHelper.java
new file mode 100644
index 000000000..0c01a0737
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/FontHelper.java
@@ -0,0 +1,75 @@
+package net.minecraft.client.render.font.renderhelper;
+
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+
+@SuppressWarnings("unused")
+public final class FontHelper {
+    public static final long CONFIG_DEFAULT = 0xFF_FF_FF_FFL;
+    private static final double @NotNull [] xPosBuffer = new double[1];
+    private static final double @NotNull [] yPosBuffer = new double[1];
+    private static final long @NotNull [] configBuffer = new long[1];
+
+    private static final RenderIntegerBase method_render = new RenderIntegerBase() { @Override public void call(@NotNull final FontRenderer fontRenderer) {
+        fontRenderer.render(this.tessellator, this.chars, this.x, this.y, this.z, this.shadow, this.config, this.xPosBuffer, this.yPosBuffer, this.configBuffer);}};
+
+    private static final RenderDoubleBase method_renderDouble = new RenderDoubleBase() { @Override public void call(@NotNull final FontRenderer fontRenderer) {
+        fontRenderer.renderDouble(this.tessellator, this.chars, this.x, this.y, this.z, this.shadow, this.config, this.xPosBuffer, this.yPosBuffer, this.configBuffer);}};
+
+    private static final RenderIntegerBase method_renderCentered = new RenderIntegerBase() { @Override public void call(@NotNull final FontRenderer fontRenderer) {
+        fontRenderer.renderCentered(this.tessellator, this.chars, this.x, this.y, this.z, this.shadow, this.config, this.xPosBuffer, this.yPosBuffer, this.configBuffer);}};
+
+    private static final RenderDoubleBase method_renderCenteredDouble = new RenderDoubleBase() { @Override public void call(@NotNull final FontRenderer fontRenderer) {
+        fontRenderer.renderCenteredDouble(this.tessellator, this.chars, this.x, this.y, this.z, this.shadow, this.config, this.xPosBuffer, this.yPosBuffer, this.configBuffer);}};
+
+    private static final RenderIntegerConstrainedBase method_renderWidthConstrained = new RenderIntegerConstrainedBase() { @Override public void call(@NotNull final FontRenderer fontRenderer) {
+        fontRenderer.renderWidthConstrained(this.tessellator, this.chars, this.x, this.y, this.z, this.shadow, this.config, this.maxWidth, this.alignment, this.xPosBuffer, this.yPosBuffer, this.configBuffer);}};
+
+    private static final RenderDoubleConstrainedBase method_renderWidthConstrainedDouble = new RenderDoubleConstrainedBase() { @Override public void call(@NotNull final FontRenderer fontRenderer) {
+        fontRenderer.renderWidthConstrainedDouble(this.tessellator, this.chars, this.x, this.y, this.z, this.shadow, this.config, this.maxWidth, this.alignment, this.xPosBuffer, this.yPosBuffer, this.configBuffer);}};
+
+    private static final RenderIntegerConstrainedBase method_renderConstrained = new RenderIntegerConstrainedBase() { @Override public void call(@NotNull final FontRenderer fontRenderer) {
+        fontRenderer.renderConstrained(this.tessellator, this.chars, this.x, this.y, this.z, this.shadow, this.config, this.maxWidth, this.maxHeight, this.alignment, this.xPosBuffer, this.yPosBuffer, this.configBuffer);}};
+
+    private static final RenderDoubleConstrainedBase method_renderConstrainedDouble = new RenderDoubleConstrainedBase() { @Override public void call(@NotNull final FontRenderer fontRenderer) {
+        fontRenderer.renderConstrainedDouble(this.tessellator, this.chars, this.x, this.y, this.z, this.shadow, this.config, this.maxWidth, this.maxHeight, this.alignment, this.xPosBuffer, this.yPosBuffer, this.configBuffer);}};
+
+    private FontHelper() {}
+
+    public static @NotNull RenderIntegerBase render(@NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final int x, final int y) {
+        return method_render.init(tessellator, chars, x, y, xPosBuffer, yPosBuffer, configBuffer);
+    }
+    public static @NotNull RenderDoubleBase renderDouble(@NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final double x, final double y) {
+        return method_renderDouble.init(tessellator, chars, x, y, xPosBuffer, yPosBuffer, configBuffer);
+    }
+    public static @NotNull RenderIntegerBase renderCentered(@NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final int x, final int y) {
+        return method_renderCentered.init(tessellator, chars, x, y, xPosBuffer, yPosBuffer, configBuffer);
+    }
+    public static @NotNull RenderDoubleBase renderDoubleCentered(@NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final double x, final double y) {
+        return method_renderCenteredDouble.init(tessellator, chars, x, y, xPosBuffer, yPosBuffer, configBuffer);
+    }
+    public static @NotNull RenderIntegerConstrainedBase renderWidthConstrained(@NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final int x, final int y, final int maxWidth) {
+        return method_renderWidthConstrained.init(tessellator, chars, x, y, maxWidth, Integer.MAX_VALUE, xPosBuffer, yPosBuffer, configBuffer);
+    }
+    public static @NotNull RenderDoubleConstrainedBase renderWidthConstrainedDouble(@NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final double x, final double y, final double maxWidth) {
+        return method_renderWidthConstrainedDouble.init(tessellator, chars, x, y, maxWidth, Double.MAX_VALUE, xPosBuffer, yPosBuffer, configBuffer);
+    }
+
+    public static int getLastEndingX() {
+        return MathHelper.ceil(xPosBuffer[0]);
+    }
+    public static double getLastEndingXDouble() {
+        return xPosBuffer[0];
+    }
+    public static int getLastEndingY() {
+        return MathHelper.ceil(yPosBuffer[0]);
+    }
+    public static double getLastEndingYDouble() {
+        return yPosBuffer[0];
+    }
+    public static long getLastConfig() {
+        return configBuffer[0];
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderDoubleBase.java b/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderDoubleBase.java
new file mode 100644
index 000000000..bbf262aea
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderDoubleBase.java
@@ -0,0 +1,98 @@
+package net.minecraft.client.render.font.renderhelper;
+
+import net.minecraft.client.render.font.SF;
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.util.helper.Color;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+@SuppressWarnings("unused")
+public abstract class RenderDoubleBase {
+    protected @NotNull Tessellator tessellator;
+    protected @NotNull CharSequence chars;
+    protected double x;
+    protected double y;
+    protected double z;
+    protected double @Nullable [] xPosBuffer;
+    protected double @Nullable [] yPosBuffer;
+    protected long @Nullable [] configBuffer;
+    protected long config;
+    protected boolean shadow;
+    RenderDoubleBase() {
+
+    }
+
+    public @NotNull RenderDoubleBase init(@NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final double x, final double y, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        this.tessellator = tessellator;
+        this.chars = chars;
+        this.x = x;
+        this.y = y;
+        this.z = 0;
+        this.xPosBuffer = xPosBuffer;
+        this.yPosBuffer = yPosBuffer;
+        this.configBuffer = configBuffer;
+        this.config = FontHelper.CONFIG_DEFAULT;
+        this.shadow = false;
+        return this;
+    }
+
+    public @NotNull RenderDoubleBase setConfig(final long config) {
+        this.config = config;
+        return this;
+    }
+
+    public @NotNull RenderDoubleBase resetConfig() {
+        this.config = FontHelper.CONFIG_DEFAULT;
+        this.shadow = false;
+        this.z = 0;
+        return this;
+    }
+
+    public @NotNull RenderDoubleBase setZ(final double zLevel) {
+        this.z = zLevel;
+        return this;
+    }
+
+    public @NotNull RenderDoubleBase setColor(final @NotNull Color color) {
+        this.config = SF.setColor(this.config, color.value);
+        return this;
+    }
+
+    public @NotNull RenderDoubleBase setColor(final int argb) {
+        this.config = SF.setColor(this.config, argb);
+        return this;
+    }
+
+    public @NotNull RenderDoubleBase setItalic() {
+        this.config = SF.setItalic(this.config);
+        return this;
+    }
+
+    public @NotNull RenderDoubleBase setUnderline() {
+        this.config = SF.setUnderline(this.config);
+        return this;
+    }
+
+    public @NotNull RenderDoubleBase setStrikethrough() {
+        this.config = SF.setStrikethrough(this.config);
+        return this;
+    }
+
+    public @NotNull RenderDoubleBase setBold() {
+        this.config = SF.setBold(this.config);
+        return this;
+    }
+
+    public @NotNull RenderDoubleBase setObfuscated() {
+        this.config = SF.setObfuscated(this.config);
+        return this;
+    }
+
+    public @NotNull RenderDoubleBase setShadow() {
+        this.shadow = true;
+        return this;
+    }
+
+    public abstract void call(@NotNull FontRenderer fontRenderer);
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderDoubleConstrainedBase.java b/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderDoubleConstrainedBase.java
new file mode 100644
index 000000000..56904dfb6
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderDoubleConstrainedBase.java
@@ -0,0 +1,110 @@
+package net.minecraft.client.render.font.renderhelper;
+
+import net.minecraft.client.render.font.Alignment;
+import net.minecraft.client.render.font.SF;
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.util.helper.Color;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+@SuppressWarnings("unused")
+public abstract class RenderDoubleConstrainedBase {
+    protected @NotNull Tessellator tessellator;
+    protected @NotNull CharSequence chars;
+    protected double x;
+    protected double y;
+    protected double z;
+    protected double maxWidth;
+    protected double maxHeight;
+    protected double @Nullable [] xPosBuffer;
+    protected double @Nullable [] yPosBuffer;
+    protected long @Nullable [] configBuffer;
+    protected @NotNull Alignment alignment;
+    protected long config;
+    protected boolean shadow;
+    RenderDoubleConstrainedBase() {
+
+    }
+
+    public @NotNull RenderDoubleConstrainedBase init(@NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final double x, final double y, final double maxWidth, final double maxHeight, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        this.tessellator = tessellator;
+        this.chars = chars;
+        this.x = x;
+        this.y = y;
+        this.z = 0;
+        this.maxWidth = maxWidth;
+        this.maxHeight = maxHeight;
+        this.xPosBuffer = xPosBuffer;
+        this.yPosBuffer = yPosBuffer;
+        this.configBuffer = configBuffer;
+        this.alignment = Alignment.LEFT;
+        this.config = FontHelper.CONFIG_DEFAULT;
+        this.shadow = false;
+        return this;
+    }
+
+    public @NotNull RenderDoubleConstrainedBase setConfig(final long config) {
+        this.config = config;
+        return this;
+    }
+
+    public @NotNull RenderDoubleConstrainedBase resetConfig() {
+        this.config = FontHelper.CONFIG_DEFAULT;
+        this.shadow = false;
+        this.z = 0;
+        return this;
+    }
+
+    public @NotNull RenderDoubleConstrainedBase setZ(final double zLevel) {
+        this.z = zLevel;
+        return this;
+    }
+
+    public @NotNull RenderDoubleConstrainedBase setColor(final @NotNull Color color) {
+        this.config = SF.setColor(this.config, color.value);
+        return this;
+    }
+
+    public @NotNull RenderDoubleConstrainedBase setColor(final int argb) {
+        this.config = SF.setColor(this.config, argb);
+        return this;
+    }
+
+    public @NotNull RenderDoubleConstrainedBase setItalic() {
+        this.config = SF.setItalic(this.config);
+        return this;
+    }
+
+    public @NotNull RenderDoubleConstrainedBase setUnderline() {
+        this.config = SF.setUnderline(this.config);
+        return this;
+    }
+
+    public @NotNull RenderDoubleConstrainedBase setStrikethrough() {
+        this.config = SF.setStrikethrough(this.config);
+        return this;
+    }
+
+    public @NotNull RenderDoubleConstrainedBase setBold() {
+        this.config = SF.setBold(this.config);
+        return this;
+    }
+
+    public @NotNull RenderDoubleConstrainedBase setObfuscated() {
+        this.config = SF.setObfuscated(this.config);
+        return this;
+    }
+
+    public @NotNull RenderDoubleConstrainedBase setShadow() {
+        this.shadow = true;
+        return this;
+    }
+
+    public @NotNull RenderDoubleConstrainedBase setAlignment(@NotNull final Alignment alignment) {
+        this.alignment = alignment;
+        return this;
+    }
+
+    public abstract void call(@NotNull FontRenderer fontRenderer);
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderIntegerBase.java b/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderIntegerBase.java
new file mode 100644
index 000000000..c92e2ad89
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderIntegerBase.java
@@ -0,0 +1,98 @@
+package net.minecraft.client.render.font.renderhelper;
+
+import net.minecraft.client.render.font.SF;
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.util.helper.Color;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+@SuppressWarnings("unused")
+public abstract class RenderIntegerBase {
+    protected @NotNull Tessellator tessellator;
+    protected @NotNull CharSequence chars;
+    protected int x;
+    protected int y;
+    protected double z;
+    protected double @Nullable [] xPosBuffer;
+    protected double @Nullable [] yPosBuffer;
+    protected long @Nullable [] configBuffer;
+    protected long config;
+    protected boolean shadow;
+    RenderIntegerBase() {
+
+    }
+
+    public @NotNull RenderIntegerBase init(@NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final int x, final int y, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        this.tessellator = tessellator;
+        this.chars = chars;
+        this.x = x;
+        this.y = y;
+        this.z = 0;
+        this.xPosBuffer = xPosBuffer;
+        this.yPosBuffer = yPosBuffer;
+        this.configBuffer = configBuffer;
+        this.config = FontHelper.CONFIG_DEFAULT;
+        this.shadow = false;
+        return this;
+    }
+
+    public @NotNull RenderIntegerBase setConfig(final long config) {
+        this.config = config;
+        return this;
+    }
+
+    public @NotNull RenderIntegerBase resetConfig() {
+        this.config = FontHelper.CONFIG_DEFAULT;
+        this.shadow = false;
+        this.z = 0;
+        return this;
+    }
+
+    public @NotNull RenderIntegerBase setZ(final double zLevel) {
+        this.z = zLevel;
+        return this;
+    }
+
+    public @NotNull RenderIntegerBase setColor(final @NotNull Color color) {
+        this.config = SF.setColor(this.config, color.value);
+        return this;
+    }
+
+    public @NotNull RenderIntegerBase setColor(final int argb) {
+        this.config = SF.setColor(this.config, argb);
+        return this;
+    }
+
+    public @NotNull RenderIntegerBase setItalic() {
+        this.config = SF.setItalic(this.config);
+        return this;
+    }
+
+    public @NotNull RenderIntegerBase setUnderline() {
+        this.config = SF.setUnderline(this.config);
+        return this;
+    }
+
+    public @NotNull RenderIntegerBase setStrikethrough() {
+        this.config = SF.setStrikethrough(this.config);
+        return this;
+    }
+
+    public @NotNull RenderIntegerBase setBold() {
+        this.config = SF.setBold(this.config);
+        return this;
+    }
+
+    public @NotNull RenderIntegerBase setObfuscated() {
+        this.config = SF.setObfuscated(this.config);
+        return this;
+    }
+
+    public @NotNull RenderIntegerBase setShadow() {
+        this.shadow = true;
+        return this;
+    }
+
+    public abstract void call(@NotNull FontRenderer fontRenderer);
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderIntegerConstrainedBase.java b/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderIntegerConstrainedBase.java
new file mode 100644
index 000000000..2abb11678
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderIntegerConstrainedBase.java
@@ -0,0 +1,110 @@
+package net.minecraft.client.render.font.renderhelper;
+
+import net.minecraft.client.render.font.Alignment;
+import net.minecraft.client.render.font.SF;
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.util.helper.Color;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+@SuppressWarnings("unused")
+public abstract class RenderIntegerConstrainedBase {
+    protected @NotNull Tessellator tessellator;
+    protected @NotNull CharSequence chars;
+    protected int x;
+    protected int y;
+    protected double z;
+    protected int maxWidth;
+    protected int maxHeight;
+    protected double @Nullable [] xPosBuffer;
+    protected double @Nullable [] yPosBuffer;
+    protected long @Nullable [] configBuffer;
+    protected @NotNull Alignment alignment;
+    protected long config;
+    protected boolean shadow;
+    RenderIntegerConstrainedBase() {
+
+    }
+
+    public @NotNull RenderIntegerConstrainedBase init(@NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final int x, final int y, final int maxWidth, final int maxHeight, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        this.tessellator = tessellator;
+        this.chars = chars;
+        this.x = x;
+        this.y = y;
+        this.z = 0;
+        this.maxWidth = maxWidth;
+        this.maxHeight = maxHeight;
+        this.xPosBuffer = xPosBuffer;
+        this.yPosBuffer = yPosBuffer;
+        this.configBuffer = configBuffer;
+        this.alignment = Alignment.LEFT;
+        this.config = FontHelper.CONFIG_DEFAULT;
+        this.shadow = false;
+        return this;
+    }
+
+    public @NotNull RenderIntegerConstrainedBase setConfig(final long config) {
+        this.config = config;
+        return this;
+    }
+
+    public @NotNull RenderIntegerConstrainedBase resetConfig() {
+        this.config = FontHelper.CONFIG_DEFAULT;
+        this.shadow = false;
+        this.z = 0;
+        return this;
+    }
+
+    public @NotNull RenderIntegerConstrainedBase setZ(final double zLevel) {
+        this.z = zLevel;
+        return this;
+    }
+
+    public @NotNull RenderIntegerConstrainedBase setColor(final @NotNull Color color) {
+        this.config = SF.setColor(this.config, color.value);
+        return this;
+    }
+
+    public @NotNull RenderIntegerConstrainedBase setColor(final int argb) {
+        this.config = SF.setColor(this.config, argb);
+        return this;
+    }
+
+    public @NotNull RenderIntegerConstrainedBase setItalic() {
+        this.config = SF.setItalic(this.config);
+        return this;
+    }
+
+    public @NotNull RenderIntegerConstrainedBase setUnderline() {
+        this.config = SF.setUnderline(this.config);
+        return this;
+    }
+
+    public @NotNull RenderIntegerConstrainedBase setStrikethrough() {
+        this.config = SF.setStrikethrough(this.config);
+        return this;
+    }
+
+    public @NotNull RenderIntegerConstrainedBase setBold() {
+        this.config = SF.setBold(this.config);
+        return this;
+    }
+
+    public @NotNull RenderIntegerConstrainedBase setObfuscated() {
+        this.config = SF.setObfuscated(this.config);
+        return this;
+    }
+
+    public @NotNull RenderIntegerConstrainedBase setShadow() {
+        this.shadow = true;
+        return this;
+    }
+
+    public @NotNull RenderIntegerConstrainedBase setAlignment(@NotNull final Alignment alignment) {
+        this.alignment = alignment;
+        return this;
+    }
+
+    public abstract void call(@NotNull FontRenderer fontRenderer);
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
index 3c7ccd1d6..9e833c112 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
@@ -1,10 +1,9 @@
 package net.minecraft.client.render.item.model;
 
 import net.minecraft.client.render.EntityRenderDispatcher;
-import net.minecraft.client.render.Font;
 import net.minecraft.client.render.ItemRenderer;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.TextureManager;
+import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.Entity;
@@ -25,7 +24,7 @@ public abstract class ItemModel {
     }
 
     public abstract void render(@NotNull Tessellator tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, @NotNull String displayPosId, boolean items3d, int clusterSize, float brightness, float alpha, float partialTick, boolean mirrorX); // TODO figure out if theres a way to not explicitly need to mirrorX in the model itself
-    public abstract void renderItemOverlayIntoGUI(@NotNull Tessellator tessellator, @NotNull Font font, @NotNull TextureManager textureManager, @NotNull ItemStack itemstack, int x, int y, @Nullable String override, float alpha);
+    public abstract void renderItemOverlayIntoGUI(@NotNull Tessellator tessellator, @NotNull FontRenderer fontRenderer, @NotNull TextureManager textureManager, @NotNull ItemStack itemstack, int x, int y, @Nullable String override, float alpha);
 
     public void renderGui(@NotNull Tessellator tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, int x, int y, float brightness, float alpha, float partialTick) {
         GL11.glPushMatrix();
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java
index 156213958..2587cc04a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.render.item.model;
 
-import net.minecraft.client.render.Font;
 import net.minecraft.client.render.TextureManager;
+import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.Entity;
@@ -16,17 +16,17 @@ public class ItemModelNone extends ItemModel{
 
 
     @Override
-    public void render(@NotNull Tessellator tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, @NotNull String displayPosId, boolean items3d, int clusterSize, float brightness, float alpha, float partialTick, boolean mirrorX) {
+    public void render(@NotNull final Tessellator tessellator, @Nullable final Entity holder, @NotNull final ItemStack itemStack, @NotNull final String displayPosId, final boolean items3d, final int clusterSize, final float brightness, final float alpha, final float partialTick, final boolean mirrorX) {
 
     }
 
     @Override
-    public void renderItemOverlayIntoGUI(@NotNull Tessellator tessellator, @NotNull Font font, @NotNull TextureManager textureManager, @NotNull ItemStack itemstack, int x, int y, @Nullable String override, float alpha) {
+    public void renderItemOverlayIntoGUI(@NotNull final Tessellator tessellator, @NotNull final FontRenderer fontRenderer, @NotNull final TextureManager textureManager, @NotNull final ItemStack itemstack, final int x, final int y, @Nullable final String override, final float alpha) {
 
     }
 
     @Override
-    public IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack) {
+    public IconCoordinate getIcon(@Nullable final Entity entity, final ItemStack itemStack) {
         return null;
     }
 }
